package cn.citycraft.ResExtras.flags;

import org.bukkit.WeatherType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

import com.bekvon.bukkit.residence.event.ResidenceChangedEvent;
import com.bekvon.bukkit.residence.event.ResidenceFlagChangeEvent;
import com.bekvon.bukkit.residence.protection.ClaimedResidence;
import com.bekvon.bukkit.residence.protection.FlagPermissions.FlagState;

public class Weather implements Listener {
	@EventHandler
	public void onResidenceChange(final ResidenceChangedEvent e) {
		final Player player = e.getPlayer();
		final ClaimedResidence oldRes = e.getFrom();
		final ClaimedResidence newRes = e.getTo();
		if (oldRes != null) {
			if (oldRes.getPermissions().isSet("weather")) {
				player.resetPlayerWeather();
			}
		}
		if (newRes != null) {
			if (newRes.getPermissions().isSet("weather")) {
				if (newRes.getPermissions().has("weather", true)) {
					player.setPlayerWeather(WeatherType.DOWNFALL);
					return;
				}
				if (!newRes.getPermissions().has("weather", false)) {
					player.setPlayerWeather(WeatherType.CLEAR);
					return;
				}
			}
		}
	}

	@EventHandler
	public void onResidenceFlag(final ResidenceFlagChangeEvent event) {
		if (event.getFlag().equalsIgnoreCase("weather")) {
			final ClaimedResidence res = event.getResidence();
			if (event.getNewState() == FlagState.TRUE) {
				for (final Player player : res.getPlayersInResidence()) {
					player.setPlayerWeather(WeatherType.DOWNFALL);
				}
			}
			if (event.getNewState() == FlagState.FALSE) {
				for (final Player player : res.getPlayersInResidence()) {
					player.setPlayerWeather(WeatherType.CLEAR);
				}
			}
			if (event.getNewState() == FlagState.NEITHER) {
				for (final Player player : res.getPlayersInResidence()) {
					player.resetPlayerWeather();
				}
			}
		}
	}
}
